<template>
  <el-row>
    <el-col v-for="user_panel in data" v-if="user_panel.panel" :key="user_panel.id" :md="12" style="padding: 10px">
      <el-card>
        <div slot="header">
          <span>{{user_panel.panel.name}}</span>
          <el-button-group style="float: right; padding: 0 3px">
            <!-- <el-button plain size="mini" @click="downloadUserPanel({ id: user_panel.id })">download</el-button> -->
            <el-button plain size="mini" @click="updateUserPanel({ id: user_panel.id, moveUp: true })">up</el-button>
            <el-button plain size="mini" @click="updateUserPanel({ id: user_panel.id, moveDown: true })">down</el-button>
            <el-button plain size="mini" @click="deleteUserPanel({ id: user_panel.id })">remove</el-button>
          </el-button-group>
        </div>
        
        <iframe :src="`/panels/${user_panel.panel.id}`" style="border: 0; width: 100%" @load="setPanelHeight($event)"></iframe>
      </el-card>
    </el-col>
  </el-row>
</template>

<script>
import gql from 'graphql-tag'

export default {
  props:['data', 'query'],

  methods: {
    setPanelHeight(event) {
      let iframe = event.target
      let iframeWin = iframe.contentWindow || iframe.contentDocument.parentWindow
      iframe.style.height = `${iframeWin.document.documentElement.scrollHeight || iframeWin.document.body.scrollHeight}px`
    },
    updateUserPanel(userPanel) {
      this.$apollo.mutate({
        mutation: gql`mutation ($userPanel: UserPanelInput!) {
          updateUserPanel(userPanel: $userPanel) {
            success
            message
            errors { field message }
          }
        }`,
        variables: { userPanel: userPanel },
        update: (store, { data: { updateUserPanel } }) => {
          if(updateUserPanel.success) {
            this.$message.success('Panel updated successfully')
            this.$props.query.refetch()
          }
          else 
            this.$message.error('Failed to update panel')
        }
      })
    },
    deleteUserPanel(userPanel) {
      this.$apollo.mutate({
        mutation: gql`mutation ($userPanel: UserPanelInput!) {
          deleteUserPanel(userPanel: $userPanel) {
            success
            message
            errors { field message }
          }
        }`,
        variables: { userPanel: userPanel },
        update: (store, { data: { deleteUserPanel } }) => {
          if(deleteUserPanel.success) {
            this.$message.success('Panel removed successfully')
            this.$props.query.refetch()
          }
          else 
            this.$message.error('Failed to remove panel')
        }
      })
    }
  }
}
</script>
